//---------------------------------------------------------------------------
#ifndef TMainFormH
#define TMainFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\DBTables.hpp>
#include <vcl\DB.hpp>
#include <vcl\DBCtrls.hpp>
#include <vcl\Mask.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
#ifdef Dbg
    #undef Dbg
#endif
#define Dbg( STR )          {                                                                               \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            DebuggingForm->ListBox->ItemIndex = DebuggingForm->ListBox->Items->Count-1;     \
                            DebuggingForm->ListBox->Update();                                               \
                            }
//---------------------------------------------------------------------------
#ifdef Msg
    #undef Msg
#endif
#define Msg( STR )          {                                                                               \
                            DebugLabel->Caption = (STR);                                                    \
                            DebugLabel->Refresh();                                                          \
                            Interfaces_DebugLabel->Caption = (STR);                                         \
                            Interfaces_DebugLabel->Refresh();                                               \
                            DebuggingForm->ListBox->Items->Add( (STR) );                          \
                            DebuggingForm->ListBox->ItemIndex = DebuggingForm->ListBox->Items->Count-1;     \
                            DebuggingForm->ListBox->Update();                                               \
                            }
//---------------------------------------------------------------------------
#ifdef ERROR
    #undef ERROR
#endif
#define ERROR( STR )        {                                                                               \
                            DebuggingForm->ListBox->Items->Add( "Error:");                                  \
                            DebuggingForm->ListBox->Items->Add( (STR) );                                    \
                            DebuggingForm->ListBox->Items->Add( "Error Line: " + ImportString );            \
                            DebuggingForm->ListBox->ItemIndex = DebuggingForm->ListBox->Items->Count-1;     \
                            DebuggingForm->Show();                                                          \
                            DebugLabel->Caption = "AN ERROR OCCURRED. Check debug output for details...";   \
                            DebugLabel->Refresh();                                                          \
                            Interfaces_DebugLabel->Caption = "AN ERROR OCCURRED. Check debug output for details...";\
                            Interfaces_DebugLabel->Refresh();                                               \
                            return;                                                                         \
                            }
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
    TTable *Structures_Table;
    TDatabase *DirectX_To_BCB;
    TDataSource *Structures_DataSource;
    TOpenDialog *ImportFileDialog;
    TQuery *TempQuery;
    TTable *StructureMembers_Table;
    TTable *StructureMemberFlags_Table;
    TDataSource *StructureMembers_DataSource;
    TDataSource *StructureMemberFlags_DataSource;
    TTable *FoundationClass_Table;
    TPageControl *DirectDrawPages;
    TTabSheet *TabSheet2;
    TPageControl *DirectXFoundationClassPages;
    TTabSheet *TabSheet6;
    TLabel *DD_StructureCount_Label;
    TLabel *DD_StructureEdit_Label;
    TLabel *DD_StructureName_Label;
    TLabel *DD_StructureDesc_Label;
    TLabel *DD_MemberCount_Label;
    TLabel *DD_PropertyEdit_Label;
    TLabel *DD_PropertyName_Label;
    TLabel *DD_PropertyDesc_Label;
    TLabel *DD_FlagCount_Label;
    TLabel *DD_FlagName_Label;
    TLabel *DD_FlagDesc_Label;
    TLabel *DD_DebugLabel;
    TTabSheet *TabSheet7;
    TLabel *DS_StructureEdit_Label;
    TLabel *DS_StructureName_Label;
    TLabel *DS_StructureDesc_Label;
    TLabel *DS_StructureCount_Label;
    TLabel *DS_MemberCount_Label;
    TLabel *DS_PropertyEdit_Label;
    TLabel *DS_PropertyName_Label;
    TLabel *DS_PropertyDesc_Label;
    TLabel *DS_FlagCount_Label;
    TLabel *DS_FlagName_Label;
    TLabel *DS_FlagDesc_Label;
    TLabel *DS_DebugLabel;
    TTabSheet *TabSheet3;
    TLabel *DI_StructureEdit_Label;
    TLabel *DI_StructureName_Label;
    TLabel *DI_StructureDesc_Label;
    TLabel *DI_StructureCount_Label;
    TLabel *DI_MemberCount_Label;
    TLabel *DI_PropertyEdit_Label;
    TLabel *DI_PropertyName_Label;
    TLabel *DI_PropertyDesc_Label;
    TLabel *DI_FlagCount_Label;
    TLabel *DI_FlagName_Label;
    TLabel *DI_FlagDesc_Label;
    TLabel *DI_DebugLabel;
    TTabSheet *TabSheet4;
    TLabel *DP_StructureEdit_Label;
    TLabel *DP_StructureName_Label;
    TLabel *DP_StructureDesc_Label;
    TLabel *DP_StructureCount_Label;
    TLabel *DP_MemberCount_Label;
    TLabel *DP_PropertyEdit_Label;
    TLabel *DP_PropertyName_Label;
    TLabel *DP_PropertyDesc_Label;
    TLabel *DP_FlagCount_Label;
    TLabel *DP_FlagName_Label;
    TLabel *DP_FlagDesc_Label;
    TLabel *DP_DebugLabel;
    TTabSheet *TabSheet10;
    TLabel *DSET_StructureEdit_Label;
    TLabel *DSET_StructureName_Label;
    TLabel *DSET_StructureDesc_Label;
    TLabel *DSET_StructureCount_Label;
    TLabel *DSET_MemberCount_Label;
    TLabel *DSET_PropertyEdit_Label;
    TLabel *DSET_PropertyName_Label;
    TLabel *DSET_PropertyDesc_Label;
    TLabel *DSET_FlagCount_Label;
    TLabel *DSET_FlagName_Label;
    TLabel *DSET_FlagDesc_Label;
    TLabel *DSET_DebugLabel;
    TTabSheet *TabSheet9;
    TLabel *D3IM_StructureEdit_Label;
    TLabel *D3IM_StructureName_Label;
    TLabel *D3IM_StructureDesc_Label;
    TLabel *D3IM_StructureCount_Label;
    TLabel *D3IM_MemberCount_Label;
    TLabel *D3IM_PropertyEdit_Label;
    TLabel *D3IM_PropertyName_Label;
    TLabel *D3IM_PropertyDesc_Label;
    TLabel *D3IM_FlagCount_Label;
    TLabel *D3IM_FlagName_Label;
    TLabel *D3IM_FlagDesc_Label;
    TLabel *D3IM_DebugLabel;
    TTabSheet *TabSheet8;
    TLabel *D3RM_StructureEdit_Label;
    TLabel *D3RM_StructureName_Label;
    TLabel *D3RM_StructureDesc_Label;
    TLabel *D3RM_StructureCount_Label;
    TLabel *D3RM_MemberCount_Label;
    TLabel *D3RM_PropertyEdit_Label;
    TLabel *D3RM_PropertyName_Label;
    TLabel *D3RM_PropertyDesc_Label;
    TLabel *D3RM_FlagCount_Label;
    TLabel *D3RM_FlagName_Label;
    TLabel *D3RM_FlagDesc_Label;
    TLabel *D3RM_DebugLabel;
    TComboBox *StructureName_ComboBox;
    TComboBox *ObjectName_ComboBox;
    TDBEdit *ObjectName_Edit;
    TDBEdit *StructureName_Edit;
    TDBMemo *ObjectDesc_Memo;
    TBitBtn *ResetObjectDesc_Button;
    TBitBtn *ResetPropertyDesc_Button;
    TDBMemo *PropertyDesc_Memo;
    TDBEdit *MemberName_Edit;
    TComboBox *MemberName_ComboBox;
    TComboBox *PropertyName_ComboBox;
    TDBEdit *PropertyName_Edit;
    TComboBox *FlagName_ComboBox;
    TDBMemo *FlagDesc_Memo;
    TDBRadioGroup *FlagStatus_RadioGroup;
    TDBRadioGroup *PropertyStatus_RadioGroup;
    TDBRadioGroup *ObjectStatus_RadioGroup;
    TBitBtn *NextStructureButton;
    TBitBtn *ImportStructuresButton;
    TBitBtn *ClearAllStructuresButton;
    TBitBtn *ToggleDebugButton;
    TBitBtn *ResetFlagDesc_Button;
    TBitBtn *PrevStructureButton;
    TBitBtn *BookmarkButton1;
    TBitBtn *BookmarkButton3;
    TBitBtn *BookmarkButton2;
    TBitBtn *BookmarkButton4;
    TTabSheet *TabSheet5;
    TPageControl *PageControl1;
    TTabSheet *TabSheet11;
    TLabel *Label1;
    TLabel *Label25;
    TLabel *Label26;
    TLabel *Label27;
    TLabel *Label28;
    TLabel *Label29;
    TLabel *Label30;
    TLabel *Label31;
    TLabel *Label32;
    TLabel *Label33;
    TLabel *Label34;
    TLabel *Interfaces_DebugLabel;
    TComboBox *DirectX_Interfaces_ComboBox;
    TDBEdit *DBEdit1;
    TDBMemo *DBMemo1;
    TDBMemo *DBMemo2;
    TDBEdit *DBEdit2;
    TComboBox *ComboBox2;
    TComboBox *ComboBox3;
    TDBMemo *DBMemo3;
    TBitBtn *BitBtn1;
    TBitBtn *BitBtn2;
    TBitBtn *BitBtn13;
    TBitBtn *BitBtn16;
    TDBRadioGroup *DBRadioGroup1;
    TDBRadioGroup *DBRadioGroup7;
    TDBRadioGroup *DBRadioGroup8;
    TTabSheet *TabSheet15;
    TLabel *Label36;
    TLabel *Label37;
    TLabel *Label38;
    TLabel *Label39;
    TLabel *Label40;
    TLabel *Label41;
    TLabel *Label42;
    TLabel *Label43;
    TLabel *Label44;
    TLabel *Label45;
    TLabel *Label46;
    TComboBox *ComboBox4;
    TDBEdit *DBEdit3;
    TDBMemo *DBMemo4;
    TComboBox *ComboBox5;
    TDBEdit *DBEdit4;
    TDBMemo *DBMemo5;
    TComboBox *ComboBox6;
    TDBMemo *DBMemo6;
    TBitBtn *BitBtn17;
    TBitBtn *BitBtn18;
    TBitBtn *BitBtn19;
    TBitBtn *BitBtn20;
    TDBRadioGroup *DBRadioGroup9;
    TDBRadioGroup *DBRadioGroup10;
    TDBRadioGroup *DBRadioGroup11;
    TTabSheet *TabSheet12;
    TTabSheet *TabSheet13;
    TTabSheet *TabSheet14;
    TTabSheet *TabSheet16;
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall FormDeactivate(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall ClearAllStructuresButtonClick(TObject *Sender);
    void __fastcall ObjectName_EditExit(TObject *Sender);
    void __fastcall PropertyName_EditExit(TObject *Sender);
    void __fastcall FlagDesc_MemoExit(TObject *Sender);
    void __fastcall DBRadioGroup1Exit(TObject *Sender);
    void __fastcall ToggleDebugButtonClick(TObject *Sender);
    void __fastcall Label7Click(TObject *Sender);
    void __fastcall Label6Click(TObject *Sender);
    void __fastcall Label5Click(TObject *Sender);
    void __fastcall Label9Click(TObject *Sender);
    void __fastcall Label14Click(TObject *Sender);
    void __fastcall Label15Click(TObject *Sender);
    void __fastcall Label16Click(TObject *Sender);
    void __fastcall Label17Click(TObject *Sender);
    void __fastcall ImportStructuresButtonClick(TObject *Sender);
    void __fastcall DirectXFoundationClassPagesChange(TObject *Sender);
    void __fastcall MemberName_ComboBoxChange(TObject *Sender);
    void __fastcall FlagName_ComboBoxChange(TObject *Sender);
    void __fastcall NextStructureButtonClick(TObject *Sender);
    void __fastcall PrevStructureButtonClick(TObject *Sender);
    void __fastcall DeleteStructureButtonClick(TObject *Sender);
    void __fastcall StructureName_ComboBoxChange(TObject *Sender);
    void __fastcall ObjectName_ComboBoxChange(TObject *Sender);
    void __fastcall PropertyName_ComboBoxChange(TObject *Sender);
    
    void __fastcall BookmarkButton1Click(TObject *Sender);
    
    
    void __fastcall BookmarkButton2Click(TObject *Sender);
    
    void __fastcall BookmarkButton3Click(TObject *Sender);
    
    
    
    
    
    void __fastcall BookmarkButton1KeyDown(TObject *Sender, WORD &Key,
    TShiftState Shift);
    void __fastcall BookmarkButton2KeyDown(TObject *Sender, WORD &Key,
    TShiftState Shift);
    void __fastcall BookmarkButton3KeyDown(TObject *Sender, WORD &Key,
    TShiftState Shift);
    void __fastcall BookmarkButton4Click(TObject *Sender);
    void __fastcall BookmarkButton4KeyDown(TObject *Sender, WORD &Key,
    TShiftState Shift);
    void __fastcall ResetObjectDesc_ButtonClick(TObject *Sender);
    void __fastcall ResetPropertyDesc_ButtonClick(TObject *Sender);
    void __fastcall ResetFlagDesc_ButtonClick(TObject *Sender);
    
protected:
private:	// User declarations

    // bits & pieces used with importing a valid DirectX_SDK text file
    
    TStringList*    fImportStrings;
    int             fImportRow;

    __property  int                 ImportRow = {read=fImportRow,write=FSetImportRow};
    __property  TStringList*        ImportStrings = {read=fImportStrings,write=fImportStrings};
    __property  AnsiString          ImportString = {read=FGetImportString};

    void        __fastcall  ImportFile( AnsiString pFileName );

    void        __fastcall  FSetImportRow( int row );
    AnsiString  __fastcall  FGetImportString();

    // general import rules

    AnsiString  __fastcall  EncodeValue( AnsiString code, int value );
    int         __fastcall  DecodeValue( AnsiString code, AnsiString encoded_string, AnsiString* decoded_string );
    AnsiString  __fastcall  RemoveHungarianNotation( AnsiString hungarian_string );

    bool    __fastcall  IsKeyword( AnsiString string, AnsiString keyword ) { return (string==keyword); }
    bool    __fastcall  IsValidStructureName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    __fastcall  IsStartOfStruct( AnsiString string ) { return (string.Pos("struct")!=0); }
    bool    __fastcall  IsEndOfStruct( AnsiString string ) { return (string.Pos("} ")!=0); }
    bool    __fastcall  IsStartOfUnion( AnsiString string ) { return (string.Pos("union")!=0); }
    bool    __fastcall  IsEndOfUnion( AnsiString string ) { return (string.Pos("};")!=0); }
    bool    __fastcall  ContainsStartBracket( AnsiString string ) { return (string.Pos("{")!=0); }
    bool    __fastcall  IsFlag( AnsiString string );
    bool    __fastcall  IsThisAndThat( TStringList* known_items, AnsiString string, AnsiString* this_string, AnsiString* that_string );
    bool    __fastcall  IsThisAndThatAndSomethingElse( TStringList* known_items, AnsiString string, TStringList* result_strings );

    // import structure bits & pieces

    TStringList*    fStructureNames;
    TStringList*    fStructureDescriptions;
    TStringList*    fMemberNames;
    TStringList*    fMemberTypes;
    TStringList*    fMemberDescriptions;
    TStringList*    fFlagNames;
    TStringList*    fFlagDescriptions;

    void        __fastcall  ImportStructures( AnsiString pFileName );
    bool        __fastcall  IsStructureName( TStringList* structure_name_strings, AnsiString structure_name );
    bool        __fastcall  IsMemberName( TStringList* member_name_strings, AnsiString member_name );

//BRIAN STARTS HERE
    // import interface bits & pieces
    bool    	__fastcall  IsValidInterfaceName( AnsiString string ) { return (string.Pos(" ")==0); }
    bool    	__fastcall  IsSingleToken( AnsiString string ) { return (string.Pos(" ")==0); }

	bool    	__fastcall  IsInterfaceName( TStringList* Interface_name_strings, AnsiString interface_name );
   	bool    	__fastcall  IsFunctionName( TStringList* function_name_strings, AnsiString function_name );
	bool    	__fastcall  HasInterfaceName( TStringList* Interface_name_strings, AnsiString interface_name );
   	bool    	__fastcall  HasFunctionName( TStringList* function_name_strings, AnsiString function_name );

    void    	__fastcall  ImportInterfaces( AnsiString pFileName );

   	TStringList*    StoredInterfaceNames;
   	TStringList*    StoredInterfaceDescriptions;
   	TStringList*    StoredFunctionNames;
   	TStringList*    StoredFunctionDescriptions;
   	TStringList*    StoredFunctionReturnTypes;
    TStringList*	StoredFunctionReturnValues;
   	TStringList*    StoredParameterTypes;
   	TStringList*    StoredParameterNames;
   	TStringList*    StoredParameterModifiers;  //can be "*" or "FAR *"
   	TStringList*    StoredParameterDescriptions;
// BRIAN ENDS HERE

    // other user-interface bits & pieces

    int     fFoundation_Class_Index;
    int     fStructure_Index;
    int     fMember_Index;
    int     fFlag_Index;
    int     fStructure_Count;
    int     fMember_Count;
    int     fFlag_Count;
    TLabel* DebugLabel;

    AnsiString fBookmarkPages[4];
    int     fBookmarkInfo[12];
    int     fPageChangeInfo[21];

    void    __fastcall  UpdateStructures();
    void    __fastcall  UpdateMembers();
    void    __fastcall  UpdateFlags();

public:		// User declarations
    __fastcall TMainForm(TComponent* Owner);
    virtual __fastcall ~TMainForm();
};
//---------------------------------------------------------------------------
extern TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif



